using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "focus_punch")]
public class FocusPunch : Script, IScriptOnBeforeTurnStart, IScriptPreventMove
{
    /// <inheritdoc />
    public void OnBeforeTurnStart(ITurnChoice choice)
    {
        choice.User.Volatile.Add(new FocusPunchEffect());
        choice.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("focus_punch_charge",
            new Dictionary<string, object>
            {
                { "pokemon", choice.User },
            }));
    }

    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        var focusPunchEffect = move.User.Volatile.Get<FocusPunchEffect>();
        if (focusPunchEffect == null || focusPunchEffect.WasHit)
        {
            prevent = true;
        }
    }
}